typedef unsigned char memory[65535]; // 64K szles bjttmb
typedef memory *memptr;              // mutatunk r
/*A SoundBlaster informcii*/
#define BASEADDR 0x220 // SB I/O port
#define IRQNUMBER 0x05 // SB IRQ
#define DMACHANNEL 0x01 // SB DMA
/*DSP parancsok*/

#define SETSAMPLERATE 0x40 // mintavtelezsi id

 // DSP kimenet

#define SPEAKERON 0xd1 // output be
#define SPEAKEROFF 0xd3 // output ki
#define SPEAKER 0xd8 // output sttusz

 // direkt md

#define DIRECTDAC 0x10 // lejtszs
#define DIRECTADC 0x20 // felvtel

 // DMA tvitel

#define DSP_DMA_STOP 0xd0 // tvitel felfggesztve
#define DSP_DMA_CONT 0xd4 // tvitel folytatsa

#define NORMALDMA_DAC 0x14 // 8 bites lejtszs
#define NORMALDMA_ADC 0x24 // 8 bites felvtel

 //impulzuskod modullt DMA tvitel

#define ADPCM4_DMA 0x74 // 4 bites ADPCM
#define ADPCM4R_DMA 0x75 // 4 bites ADPCM referencival
#define ADPCM26_DMA 0x76 // 2.6 bites ADPCM
#define ADPCM26R_DMA 0x77 // 2.6 bites ADPCM referencival
#define ADPCM2_DMA 0x16 // 2 bites ADPCM
#define ADPCM2R_DMA 0x17 // -||- referencival

 // egyb

#define GETDSPVER 0xe1 // verziszm

char dspreset()
{
	asm mov dx,BASEADDR
	asm add dl,6 // 226:DSP reset reg
	asm mov al,1
	asm out dx,al // dx-226
	asm mov cx,100
	asm rep lodsb
	asm xor al,al
	asm out dx,al
	asm add dl,8
	asm mov cx,128
wait1:
	asm in al,dx
	asm and al,0x80
	asm jnz test2
	asm loop wait1
	asm jmp bad
test2:
	asm mov cx,10240
	asm sub dl,4 // dx-22a
wait2:
	asm in  al,dx // dx-22a
	asm cmp al,0x0aa
	asm jz good
	asm loop wait2
bad:
	asm xor al,al
	asm jmp exit
good:
	asm mov al,1
exit:
	asm ret
}

void dspwrite(unsigned char dspdata)
{
	asm mov dx,BASEADDR
	asm add dl,0x0c
c1:
	asm in al,dx
	asm and al,0x80
	asm jnz c1
	asm mov al,dspdata
	asm out dx,al
	asm ret
}

unsigned char dspread()
{
	asm mov dx,BASEADDR
	asm add dl,0x0e
wait:
	asm in al,dx
	asm and al,0x80
	asm jz wait
	asm sub dl,4
	asm in al,dx
}

void dspspeakeron()
{
	dspwrite(SPEAKERON);
}

void dspspeakeroff()
{
	dspwrite(SPEAKEROFF);
}

void pause(unsigned short atime)
{
	asm mov cx,atime
wait:
	asm nop
	asm nop
	asm loop wait
}






























