/*  typeinfo.h

    Definitions for RTTI
*/

/*
 *      C/C++ Run Time Library - Version 6.0
 *
 *      Copyright (c) 1987, 1993 by Borland International
 *      All Rights Reserved.
 *
 */

#ifndef __TYPEINFO_H
#define __TYPEINFO_H

#if !defined(___DEFS_H)
#include <_defs.h>
#endif

#pragma option  -Vt-                    // make sure vtable pointer is 'low'
#pragma option  -RT-                    // make sure __rtti is not default


#if defined(_BUILDRTLDLL) || defined(_RTLDLL)
#   define _TIDIST   _EXPCLASS
#else
#   if defined(__FLAT__)
#     define _TIDIST
#   else
#      if     defined(__LARGE__) || defined(__COMPACT__) || defined(__HUGE__)
#         define _TIDIST  __huge
#      else
#         define _TIDIST  __huge __near
#      endif
#   endif
#endif

class                   tpid;

class   _TIDIST  __rtti  Type_info
{

public:

#if defined(__FLAT__)
        tpid          *         tpp;
#else
        tpid    __far *         tpp;
#endif

private:
                __cdecl Type_info(const Type_info &);
    Type_info & __cdecl operator=(const Type_info &);

public:

    virtual     __cdecl ~Type_info();

    int         __cdecl operator==(const Type_info &) const;
    int         __cdecl operator!=(const Type_info &) const;

    int         __cdecl before(const Type_info &);

    const char *__cdecl name() const;
#if !defined(__FLAT__)
    const char  __far * __cdecl fname() const;
#endif
};

class   Bad_cast{};
class   Bad_typeid{};

#pragma option  -RT.
#pragma option  -Vt.

#endif
